3 # git-submodules.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 USAGE="[--quiet] [--cached] \
8 [add <repo> [-b branch] <path>]|[status|init|update [-i|--init]|summary [-n|--summary-limit <n>] [<commit>]] \
9 [--] [<path>...]|[foreach <command>]"
20 # print stuff on stdout unless -q was specified
30 # Resolve relative url by appending to parent's url
31 resolve_relative_url ()
33 branch="$(git symbolic-ref HEAD 2>/dev/null)"
34 remote="$(git config branch.${branch#refs/heads/}.remote)"
35 remote="${remote:-origin}"
36 remoteurl=$(git config "remote.$remote.url") ||
37 die "remote ($remote) does not have a url defined in .git/config"
44 remoteurl="${remoteurl%/*}"
53 echo "$remoteurl/$url"
57 # Map submodule path to submodule name
63 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
64 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
65 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
66 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
68 die "No submodule mapping found in .gitmodules for path '$path'"
75 # Prior to calling, cmd_update checks that a possibly existing
76 # path is not a git repository.
77 # Likewise, cmd_add checks that path does not exist at all,
78 # since it is the location of a new submodule.
85 # If there already is a directory at the submodule path,
86 # expect it to be empty (since that is the default checkout
87 # action) and try to remove it.
88 # Note: if $path is a symlink to a directory the test will
89 # succeed but the rmdir will fail. We might want to fix this.
92 rmdir "$path" 2>/dev/null ||
93 die "Directory '$path' exist, but is neither empty nor a git repository"
97 die "A file already exist at path '$path'"
99 git-clone -n "$url" "$path" ||
100 die "Clone of '$url' into submodule path '$path' failed"
104 # Add a new submodule to the working tree, .gitmodules and the index
108 # optional branch is stored in global branch variable
112 # parse $args after "submodule ... add".
117 case "$2" in '') usage ;; esac
141 if test -z "$repo" -o -z "$path"; then
145 # assure repo is absolute or relative to parent
148 # dereference source url relative to parent's url
149 realrepo=$(resolve_relative_url "$repo") || exit
156 die "repo URL: '$repo' must be absolute or begin with ./|../"
160 # strip trailing slashes from path
161 path=$(echo "$path" | sed -e 's|/*$||')
163 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
164 die "'$path' already exists in the index"
166 # perhaps the path exists and is already a git repo, else clone it
169 if test -d "$path"/.git -o -f "$path"/.git
171 echo "Adding existing repo at '$path' to the index"
173 die "'$path' already exists and is not a valid git repo"
178 url=$(resolve_relative_url "$repo") || exit
184 git config submodule."$path".url "$url"
187 module_clone "$path" "$realrepo" || exit
188 (unset GIT_DIR; cd "$path" && git checkout -q ${branch:+-b "$branch" "origin/$branch"}) ||
189 die "Unable to checkout submodule '$path'"
193 die "Failed to add submodule '$path'"
195 git config -f .gitmodules submodule."$path".path "$path" &&
196 git config -f .gitmodules submodule."$path".url "$repo" &&
197 git add .gitmodules ||
198 die "Failed to register submodule '$path'"
202 # Execute an arbitrary command sequence in each checked out
205 # $@ = command to execute
209 git ls-files --stage | grep '^160000 ' |
210 while read mode sha1 stage path
212 if test -e "$path"/.git
214 say "Entering '$path'"
215 (cd "$path" && eval "$@") ||
216 die "Stopping at '$path'; script returned non-zero status."
222 # Register submodules in .git/config
224 # $@ = requested paths (default to all)
228 # parse $args after "submodule ... init".
249 git ls-files --stage -- "$@" | grep '^160000 ' |
250 while read mode sha1 stage path
252 # Skip already registered paths
253 name=$(module_name "$path") || exit
254 url=$(git config submodule."$name".url)
255 test -z "$url" || continue
257 url=$(git config -f .gitmodules submodule."$name".url)
259 die "No url found for submodule path '$path' in .gitmodules"
261 # Possibly a url relative to parent
264 url=$(resolve_relative_url "$url") || exit
268 git config submodule."$name".url "$url" ||
269 die "Failed to register url for submodule path '$path'"
271 say "Submodule '$name' ($url) registered for path '$path'"
276 # Update each submodule path to correct revision, using clone and checkout as needed
278 # $@ = requested paths (default to all)
282 # parse $args after "submodule ... update".
292 cmd_init "$@" || return
307 git ls-files --stage -- "$@" | grep '^160000 ' |
308 while read mode sha1 stage path
310 name=$(module_name "$path") || exit
311 url=$(git config submodule."$name".url)
314 # Only mention uninitialized submodules when its
315 # path have been specified
317 say "Submodule path '$path' not initialized"
318 say "Maybe you want to use 'update --init'?"
322 if ! test -d "$path"/.git -o -f "$path"/.git
324 module_clone "$path" "$url" || exit
327 subsha1=$(unset GIT_DIR; cd "$path" &&
328 git rev-parse --verify HEAD) ||
329 die "Unable to find current revision in submodule path '$path'"
332 if test "$subsha1" != "$sha1"
334 (unset GIT_DIR; cd "$path" && git-fetch &&
335 git-checkout -q "$sha1") ||
336 die "Unable to checkout '$sha1' in submodule path '$path'"
338 say "Submodule path '$path': checked out '$sha1'"
347 git describe "$2" 2>/dev/null ||
348 git describe --tags "$2" 2>/dev/null ||
349 git describe --contains "$2" 2>/dev/null ||
350 git describe --all --always "$2"
353 test -z "$revname" || revname=" ($revname)"
356 # Show commit summary for submodules in index or working tree
358 # If '--cached' is given, show summary between index and given commit,
359 # or between working tree and given commit
361 # $@ = [commit (default 'HEAD'),] requested paths (default all)
367 # parse $args after "submodule ... summary".
378 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
400 test $summary_limit = 0 && return
402 if rev=$(git rev-parse --verify "$1^0" 2>/dev/null)
411 # Get modified modules cared by user
412 modules=$(git diff-index $cached --raw $head -- "$@" |
413 grep -e '^:160000' -e '^:[0-7]* 160000' |
414 while read mod_src mod_dst sha1_src sha1_dst status name
416 # Always show modules deleted or type-changed (blob<->module)
417 test $status = D -o $status = T && echo "$name" && continue
418 # Also show added or modified modules which are checked out
419 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
424 test -z "$modules" && return
426 git diff-index $cached --raw $head -- $modules |
427 grep -e '^:160000' -e '^:[0-7]* 160000' |
429 while read mod_src mod_dst sha1_src sha1_dst status name
431 if test -z "$cached" &&
432 test $sha1_dst = 0000000000000000000000000000000000000000
436 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
438 100644 | 100755 | 120000)
439 sha1_dst=$(git hash-object $name)
445 echo >&2 "unexpected mode $mod_dst"
452 test $mod_src = 160000 &&
453 ! GIT_DIR="$name/.git" git-rev-parse --verify $sha1_src^0 >/dev/null 2>&1 &&
456 test $mod_dst = 160000 &&
457 ! GIT_DIR="$name/.git" git-rev-parse --verify $sha1_dst^0 >/dev/null 2>&1 &&
461 case "$missing_src,$missing_dst" in
463 errmsg=" Warn: $name doesn't contain commit $sha1_src"
466 errmsg=" Warn: $name doesn't contain commit $sha1_dst"
469 errmsg=" Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
474 if test $mod_src = 160000 -a $mod_dst = 160000
476 range="$sha1_src...$sha1_dst"
477 elif test $mod_src = 160000
483 GIT_DIR="$name/.git" \
484 git log --pretty=oneline --first-parent $range | wc -l
486 total_commits=" ($(($total_commits + 0)))"
490 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
491 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
494 if test $mod_dst = 160000
496 echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
498 echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
501 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
505 # Don't give error msg for modification whose dst is not submodule
506 # i.e. deleted or changed to blob
507 test $mod_dst = 160000 && echo "$errmsg"
509 if test $mod_src = 160000 -a $mod_dst = 160000
512 test $summary_limit -gt 0 && limit="-$summary_limit"
513 GIT_DIR="$name/.git" \
514 git log $limit --pretty='format: %m %s' \
515 --first-parent $sha1_src...$sha1_dst
516 elif test $mod_dst = 160000
518 GIT_DIR="$name/.git" \
519 git log --pretty='format: > %s' -1 $sha1_dst
521 GIT_DIR="$name/.git" \
522 git log --pretty='format: < %s' -1 $sha1_src
528 if test -n "$for_status"; then
529 echo "# Modified submodules:"
531 sed -e 's|^|# |' -e 's|^# $|#|'
537 # List all submodules, prefixed with:
538 # - submodule not initialized
539 # + different revision checked out
541 # If --cached was specified the revision in the index will be printed
542 # instead of the currently checked out revision.
544 # $@ = requested paths (default to all)
548 # parse $args after "submodule ... status".
572 git ls-files --stage -- "$@" | grep '^160000 ' |
573 while read mode sha1 stage path
575 name=$(module_name "$path") || exit
576 url=$(git config submodule."$name".url)
577 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
582 set_name_rev "$path" "$sha1"
583 if git diff-files --quiet -- "$path"
585 say " $sha1 $path$revname"
589 sha1=$(unset GIT_DIR; cd "$path" && git rev-parse --verify HEAD)
590 set_name_rev "$path" "$sha1"
592 say "+$sha1 $path$revname"
597 # This loop parses the command line arguments to find the
598 # subcommand name to dispatch. Parsing of the subcommand specific
599 # options are primarily done by the subcommand implementations.
600 # Subcommand specific options such as --branch and --cached are
601 # parsed here as well, for backward compatibility.
603 while test $# != 0 && test -z "$command"
606 add | foreach | init | update | status | summary)
636 # No command word defaults to "status"
637 test -n "$command" || command=status
639 # "-b branch" is accepted only by "add"
640 if test -n "$branch" && test "$command" != add
645 # "--cached" is accepted only by "status" and "summary"
646 if test -n "$cached" && test "$command" != status -a "$command" != summary